import { JWTToken } from "./jwt";
import { Algorithm, Issuer, IssuerOptions, IssueTokenOptions, JWTPayloadOptions, JWTPayloadOptionsDefault, Key } from "../types";
import { JWTTokenVerifier } from "./verifier";
export declare class JWTTokenIssuer<O extends JWTPayloadOptions = JWTPayloadOptionsDefault, P extends {} | undefined = undefined, H extends {} | undefined = undefined> extends JWTTokenVerifier<O, P, H> implements Issuer<JWTToken<O, P, H, true>, IssueTokenOptions<O, P, H>> {
    protected readonly privateKey: Key;
    readonly headers: H;
    readonly algorithm: Algorithm;
    readonly validTimeMs: number;
    readonly validityDelayMs: number;
    readonly nameOrUrl: O["jti"];
    readonly defaultAdditionalPayload: P;
    protected generateJWTID: () => O["jti"];
    constructor(key: Key, issuerOptions: IssuerOptions<O, P, H>);
    issueToken(options: IssueTokenOptions<O, P, H>): Promise<JWTToken<O, P, H, true>>;
}
//# sourceMappingURL=issuer.d.ts.map