"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JWTPayload = exports.JWTHeader = exports.JWTToken = void 0;
var types_1 = require("../types");
var utils_1 = require("../utils");
var base64url_1 = __importDefault(require("base64url"));
var jose = __importStar(require("jose"));
var ROUND_DEC_PLACES = 2;
var TIME_UNIT = "seconds";
var JWTToken = (function () {
    function JWTToken(options) {
        this.header = new JWTHeader({
            alg: options.algorithm,
            additionalHeaders: options.additionalHeaders,
        });
        this.payload = new JWTPayload({
            iss: options.issuer,
            sub: options.subject,
            aud: options.audience,
            exp: options.expiration,
            nbf: options.notBefore,
            iat: options.issuedAt,
            jti: options.jwtID,
            additionalPayload: options.additionalPayload,
        });
        this.signature = options.signature;
    }
    JWTToken.prototype.toJSON = function () {
        return {
            header: this.header.toJSON(),
            payload: this.payload.toJSON(),
            signature: this.signature,
        };
    };
    JWTToken.prototype.toString = function () {
        return "".concat(this.header.toString(), ".").concat(this.payload.toString(), ".").concat(this.signature ? this.signature.toString() : "");
    };
    JWTToken.prototype.getSignableString = function () {
        return (0, utils_1.getSignableString)(this.header, this.payload);
    };
    JWTToken.prototype.isSigned = function () {
        if (this.signature === undefined)
            return false;
        return true;
    };
    JWTToken.prototype.isNotExpired = function (reseve, at) {
        if (reseve === void 0) { reseve = 1000; }
        if (at === void 0) { at = new Date(); }
        return this.payload.exp.getTime() - at.getTime() > reseve;
    };
    JWTToken.prototype.isAfterNotBefore = function (at) {
        if (at === void 0) { at = new Date(); }
        if (!this.payload.nbf)
            return true;
        return this.payload.nbf.getTime() <= at.getTime();
    };
    JWTToken.prototype.isTimeValid = function (reserve, at) {
        if (reserve === void 0) { reserve = 1000; }
        if (at === void 0) { at = new Date(); }
        return this.isNotExpired(reserve, at) && this.isAfterNotBefore(at);
    };
    JWTToken.prototype.isCorrectAudience = function (audience) {
        if (this.payload.aud === undefined)
            return true;
        if (Array.isArray(this.payload.aud)) {
            return this.payload.aud.includes(audience);
        }
        return this.payload.aud === audience;
    };
    JWTToken.prototype.isIssuedAfter = function (at) {
        if (at === void 0) { at = new Date(); }
        if (!this.payload.iat)
            return undefined;
        return this.payload.iat.getTime() <= at.getTime();
    };
    JWTToken.prototype.isFromTrustedIssuer = function (issuerIsTrusted) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.payload.iss === undefined)
                            return [2, false];
                        if (Array.isArray(issuerIsTrusted)) {
                            return [2, issuerIsTrusted.includes(this.payload.iss)];
                        }
                        if (!(typeof issuerIsTrusted === "function")) return [3, 2];
                        return [4, issuerIsTrusted(this.payload.iss)];
                    case 1: return [2, _a.sent()];
                    case 2: return [2, this.payload.iss === issuerIsTrusted];
                }
            });
        });
    };
    JWTToken.prototype.getSignature = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var sign;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, new jose.SignJWT(this.payload.toJSON())
                            .setProtectedHeader(this.header.toJSON())
                            .sign(key)];
                    case 1:
                        sign = _a.sent();
                        return [2, sign.split(".").at(-1)];
                }
            });
        });
    };
    JWTToken.prototype.sign = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var signature, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.getSignature(key)];
                    case 1:
                        signature = _a.sent();
                        json = this.toJSON();
                        json.signature = signature;
                        return [2, JWTToken.fromJSON(json)];
                }
            });
        });
    };
    JWTToken.prototype.verifySignature = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, jose.jwtVerify(this.toString(), key)];
                    case 1:
                        _a.sent();
                        return [3, 3];
                    case 2:
                        e_1 = _a.sent();
                        return [2, false];
                    case 3: return [2, true];
                }
            });
        });
    };
    JWTToken.prototype.verify = function (key, reserve, at, issuerIsTrusted, audience) {
        if (reserve === void 0) { reserve = 1000; }
        if (at === void 0) { at = new Date(); }
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4, this.verifySignature(key)];
                    case 1:
                        _a = (_c.sent()) &&
                            this.isTimeValid(reserve, at) &&
                            (audience === undefined ? true : this.isCorrectAudience(audience));
                        if (!_a) return [3, 5];
                        if (!(issuerIsTrusted === undefined)) return [3, 2];
                        _b = true;
                        return [3, 4];
                    case 2: return [4, this.isFromTrustedIssuer(issuerIsTrusted)];
                    case 3:
                        _b = _c.sent();
                        _c.label = 4;
                    case 4:
                        _a = (_b);
                        _c.label = 5;
                    case 5: return [2, (_a)];
                }
            });
        });
    };
    JWTToken.fromJSON = function (json) {
        return new JWTToken({
            algorithm: json.header.alg,
            issuer: json.payload.iss,
            subject: json.payload.sub,
            audience: json.payload.aud,
            expiration: new Date(json.payload.exp / types_1.TimeUnitsMSMultiplierMap[TIME_UNIT]),
            issuedAt: json.payload.iat === undefined
                ? undefined
                : new Date(json.payload.iat / types_1.TimeUnitsMSMultiplierMap[TIME_UNIT]),
            notBefore: json.payload.nbf === undefined
                ? undefined
                : new Date(json.payload.nbf / types_1.TimeUnitsMSMultiplierMap[TIME_UNIT]),
            jwtID: json.payload.jti,
            signature: json.signature,
            additionalHeaders: (0, utils_1.filterObject)(json.header, function (key) { return !["alg", "typ"].includes(key); }),
            additionalPayload: (0, utils_1.filterObject)(json.payload, function (key) { return !["iss", "sub", "aud", "exp", "iat", "nbf", "jti"].includes(key); }),
        });
    };
    JWTToken.fromString = function (token) {
        var _a = __read(token.split("."), 3), header = _a[0], payload = _a[1], signature = _a[2];
        if (!header || !payload) {
            throw new Error("Invalid JWT token");
        }
        if (signature === undefined) {
            throw new Error("Invalid JWT token. Unsigned tokens must end with a period. See JWT specification.");
        }
        return JWTToken.fromJSON({
            header: JWTHeader.fromString(header).toJSON(),
            payload: JWTPayload.fromString(payload).toJSON(),
            signature: (signature == "" ? undefined : signature),
        });
    };
    return JWTToken;
}());
exports.JWTToken = JWTToken;
var JWTHeader = (function () {
    function JWTHeader(options) {
        if (!(0, utils_1.isValidAlgorithm)(options.alg))
            throw new Error("Invalid algorithm");
        this.alg = options.alg;
        this.typ = "JWT";
        this.additional = (options.additionalHeaders === undefined ? {} : options.additionalHeaders);
    }
    JWTHeader.prototype.toJSON = function () {
        return __assign({ alg: this.alg, typ: this.typ }, this.additional);
    };
    JWTHeader.prototype.toString = function () {
        return base64url_1.default.encode(JSON.stringify(this.toJSON()), "utf-8");
    };
    JWTHeader.fromJSON = function (headers) {
        return new JWTHeader({
            alg: headers.alg,
            additionalHeaders: (0, utils_1.filterObject)(headers, function (key) { return !["alg"].includes(key); }),
        });
    };
    JWTHeader.fromString = function (header) {
        return this.fromJSON(JSON.parse(base64url_1.default.decode(header)));
    };
    return JWTHeader;
}());
exports.JWTHeader = JWTHeader;
var JWTPayload = (function () {
    function JWTPayload(options) {
        this.iss = options.iss;
        this.sub = options.sub;
        this.aud = options.aud;
        this.exp = options.exp;
        this.nbf = options.nbf;
        this.iat = options.iat;
        this.jti = options.jti;
        this.additional = (options.additionalPayload === undefined ? {} : options.additionalPayload);
    }
    JWTPayload.prototype.toJSON = function () {
        var _a, _b;
        return __assign({ iss: this.iss, sub: this.sub, aud: this.aud, exp: (0, utils_1.roundDecPlaces)(this.exp.getTime() * types_1.TimeUnitsMSMultiplierMap[TIME_UNIT], ROUND_DEC_PLACES), nbf: ((_a = this.nbf) === null || _a === void 0 ? void 0 : _a.getTime()) === undefined
                ? undefined
                : (0, utils_1.roundDecPlaces)(this.nbf.getTime() * types_1.TimeUnitsMSMultiplierMap[TIME_UNIT], ROUND_DEC_PLACES), iat: ((_b = this.iat) === null || _b === void 0 ? void 0 : _b.getTime()) === undefined
                ? undefined
                : (0, utils_1.roundDecPlaces)(this.iat.getTime() * types_1.TimeUnitsMSMultiplierMap[TIME_UNIT], ROUND_DEC_PLACES), jti: this.jti }, this.additional);
    };
    JWTPayload.prototype.toString = function () {
        return base64url_1.default.encode(JSON.stringify(this.toJSON()), "utf-8");
    };
    JWTPayload.fromJSON = function (payload) {
        return new JWTPayload({
            aud: payload.aud,
            exp: new Date(payload.exp * 1000),
            iat: payload.iat === undefined ? undefined : new Date(payload.iat * 1000),
            iss: payload.iss,
            jti: payload.jti,
            nbf: payload.nbf === undefined ? undefined : new Date(payload.nbf * 1000),
            sub: payload.sub,
            additionalPayload: (0, utils_1.filterObject)(payload, function (key) { return !["aud", "exp", "iat", "iss", "jti", "nbf", "sub"].includes(key); }),
        });
    };
    JWTPayload.fromString = function (payload) {
        return this.fromJSON(JSON.parse(base64url_1.default.decode(payload)));
    };
    return JWTPayload;
}());
exports.JWTPayload = JWTPayload;
//# sourceMappingURL=jwt.js.map