"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JWTTokenParser = void 0;
var jwt_1 = require("./jwt");
var JWTTokenParser = (function () {
    function JWTTokenParser(expectSigned) {
        this.expectSigned = expectSigned;
    }
    JWTTokenParser.prototype.parseToken = function (token) {
        var t = jwt_1.JWTToken.fromString(token);
        if (t.isSigned() !== this.expectSigned)
            throw new Error(this.expectSigned ? "Token is not signed" : "Token is signed");
        return Promise.resolve(t);
    };
    return JWTTokenParser;
}());
exports.JWTTokenParser = JWTTokenParser;
//# sourceMappingURL=parser.js.map