"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.roundDecPlaces = exports.getSignableString = exports.filterObject = exports.isValidAlgorithm = void 0;
var types_1 = require("./types");
function isValidAlgorithm(alg) {
    if (typeof alg !== "string")
        return false;
    return types_1.ALGORITHMS.includes(alg);
}
exports.isValidAlgorithm = isValidAlgorithm;
function filterObject(obj, selector) {
    var filtered = {};
    for (var key in obj) {
        if (selector(key, obj[key])) {
            filtered[key] = obj[key];
        }
    }
    return filtered;
}
exports.filterObject = filterObject;
function getSignableString(header, payload) {
    return "".concat(header.toString(), ".").concat(payload.toString());
}
exports.getSignableString = getSignableString;
function roundDecPlaces(num, places) {
    var multiplier = Math.pow(10, places);
    return Math.round(num * multiplier) / multiplier;
}
exports.roundDecPlaces = roundDecPlaces;
//# sourceMappingURL=utils.js.map